VERSION 5.00
Begin VB.Form frmCSPs 
   Caption         =   "Cryptographic Service Providers"
   ClientHeight    =   4575
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5295
   LinkTopic       =   "Form1"
   ScaleHeight     =   4575
   ScaleWidth      =   5295
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdExit 
      Caption         =   "E&xit"
      Height          =   375
      Left            =   3870
      TabIndex        =   2
      Top             =   120
      Width           =   1335
   End
   Begin VB.CommandButton cmdTypes 
      Caption         =   "List CSP &Types"
      Height          =   375
      Left            =   1980
      TabIndex        =   1
      Top             =   120
      Width           =   1335
   End
   Begin VB.CommandButton cmdListCSPs 
      Caption         =   "List &CSPs"
      Height          =   375
      Left            =   90
      TabIndex        =   0
      Top             =   120
      Width           =   1335
   End
   Begin VB.Label lblList 
      Height          =   3855
      Left            =   120
      TabIndex        =   3
      Top             =   600
      Width           =   5055
   End
End
Attribute VB_Name = "frmCSPs"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function CryptEnumProviderTypes Lib "advapi32.dll" Alias "CryptEnumProviderTypesA" ( _
    ByVal dwIndex As Long, _
    ByVal pdwReserved As Long, _
    ByVal dwFlags As Long, _
    pdwProvType As Long, _
    ByVal pszTypeName As String, _
    pcbTypeName As Long) As Long

Private Declare Function CryptEnumProviders Lib "advapi32.dll" Alias "CryptEnumProvidersA" ( _
    ByVal dwIndex As Long, _
    ByVal pdwReserved As Long, _
    ByVal dwFlags As Long, _
    pdwProvType As Long, _
    ByVal pszProvName As String, _
    pcbProvName As Long) As Long

Private Sub cmdExit_Click()
    Unload Me
End Sub

Private Sub cmdListCSPs_Click()
    EnumCSPs
End Sub

Private Sub cmdTypes_Click()
    EnumTypes
End Sub

Private Sub EnumCSPs()
'*************************************************************
'* Written By: Davis Chapman
'* Date:       September 22, 1999
'*
'* Syntax:     EnumCSPs
'*
'* Parameters:  None
'*
'* Purpose: This subroutine loops through all of the CSPs
'*          installed on the system, listing them for the user.
'*************************************************************
    Dim lResult As Long
    Dim lIndex As Long
    Dim sNameBuffer As String
    Dim lNameLength As Long
    Dim lProvType As Long
    
    '--- Initialize the necessary variables
    lIndex = 0
    lblList.Caption = ""
    
    '--- Determine the size of the buffer needed
    lResult = CryptEnumProviders(lIndex, 0, 0, lProvType, vbNullString, lNameLength)
    
    '--- Prepare a string buffer for the CryptEncrypt function
    sNameBuffer = String(lNameLength, vbNullChar)
    
    '--- Get the provider name, looping until all providers have been listed
    While CBool(CryptEnumProviders(lIndex, 0, 0, lProvType, sNameBuffer, _
            lNameLength))
        
        '--- Add the current CSP to the display list
        If (lIndex > 0) Then lblList.Caption = lblList.Caption + vbCrLf
        lblList.Caption = lblList.Caption + sNameBuffer
        
        '--- Increment the index counter
        lIndex = lIndex + 1
        
        '--- Determine the size of the buffer needed
        lResult = CryptEnumProviders(lIndex, 0, 0, lProvType, vbNullString, lNameLength)
        
        '--- Prepare a string buffer for the CryptEncrypt function
        sNameBuffer = String(lNameLength, vbNullChar)
    Wend
End Sub

Private Sub EnumTypes()
'*************************************************************
'* Written By: Davis Chapman
'* Date:       September 22, 1999
'*
'* Syntax:     EnumTypes
'*
'* Parameters:  None
'*
'* Purpose: This subroutine loops through all of the CSP types
'*          installed on the system, listing them for the user.
'*************************************************************
    Dim lResult As Long
    Dim lIndex As Long
    Dim sNameBuffer As String
    Dim lNameLength As Long
    Dim lProvType As Long
    
    '--- Initialize the necessary variables
    lIndex = 0
    lblList.Caption = ""
    
    '--- Determine the size of the buffer needed
    lResult = CryptEnumProviderTypes(lIndex, 0, 0, lProvType, vbNullString, lNameLength)
    
    '--- Prepare a string buffer for the CryptEncrypt function
    sNameBuffer = String(lNameLength, vbNullChar)
    
    '--- Get the type name, looping until all types have been listed
    While CBool(CryptEnumProviderTypes(lIndex, 0, 0, lProvType, sNameBuffer, _
            lNameLength))
        
        '--- Add the current CSP to the display list
        If (lIndex > 0) Then lblList.Caption = lblList.Caption + vbCrLf
        lblList.Caption = lblList.Caption + sNameBuffer
        
        '--- Increment the index counter
        lIndex = lIndex + 1
        
        '--- Determine the size of the buffer needed
        lResult = CryptEnumProviderTypes(lIndex, 0, 0, lProvType, vbNullString, lNameLength)
        
        '--- Prepare a string buffer for the CryptEncrypt function
        sNameBuffer = String(lNameLength, vbNullChar)
    Wend
End Sub

