VERSION 5.00
Begin VB.Form frmListUsers 
   Caption         =   "Domain Users and Groups"
   ClientHeight    =   5775
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   8280
   LinkTopic       =   "Form1"
   ScaleHeight     =   5775
   ScaleWidth      =   8280
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame Frame1 
      Caption         =   "List"
      Height          =   1935
      Left            =   120
      TabIndex        =   4
      Top             =   600
      Width           =   2415
      Begin VB.OptionButton optMemGroups 
         Caption         =   "Members with Groups"
         Height          =   375
         Left            =   120
         TabIndex        =   8
         Top             =   1440
         Width           =   2175
      End
      Begin VB.OptionButton optMembers 
         Caption         =   "Members"
         Height          =   375
         Left            =   120
         TabIndex        =   7
         Top             =   1040
         Width           =   1815
      End
      Begin VB.OptionButton optGroupsUsers 
         Caption         =   "Groups with Members"
         Height          =   375
         Left            =   120
         TabIndex        =   6
         Top             =   640
         Width           =   2055
      End
      Begin VB.OptionButton optGroups 
         Caption         =   "Groups"
         Height          =   375
         Left            =   120
         TabIndex        =   5
         Top             =   240
         Value           =   -1  'True
         Width           =   1815
      End
   End
   Begin VB.TextBox txtDomain 
      Height          =   375
      Left            =   2640
      TabIndex        =   3
      Top             =   120
      Width           =   2775
   End
   Begin VB.TextBox txtResults 
      Height          =   5055
      Left            =   2640
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   1
      Top             =   600
      Width           =   5535
   End
   Begin VB.CommandButton cmdList 
      Caption         =   "List"
      Height          =   495
      Left            =   840
      TabIndex        =   0
      Top             =   2640
      Width           =   1695
   End
   Begin VB.Label Label1 
      Caption         =   "Domain:"
      Height          =   255
      Left            =   360
      TabIndex        =   2
      Top             =   120
      Width           =   2055
   End
End
Attribute VB_Name = "frmListUsers"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit


Private Sub ListGroups()
'*************************************************************
'* Written By: Davis Chapman
'* Date:       February 12, 2000
'*
'* Syntax:     ListGroups
'*
'* Parameters: None
'*
'* Purpose: This subroutine builds a list of the groups in the
'*          specified domain. The list of groups is displayed
'*          in the txtResults text box.
'*************************************************************
    Dim myDomain As Object
    Dim objGroup As IADsGroup
    Dim strMsg As String
    Dim strDomain As String
    
    '--- Build the domain string
    strDomain = "WinNT://" + txtDomain
    '--- Get the domain object
    Set myDomain = GetObject(strDomain)
    '--- Filter for groups
    myDomain.Filter = Array("group")
    '--- Initialize the display string
    strMsg = ""
    '--- Loop through the groups in the domain
    For Each objGroup In myDomain
        '--- Add the current group to the display string
        strMsg = strMsg + objGroup.Name + vbCrLf
    Next
    '--- Display the list of groups
    txtResults = strMsg
End Sub

Private Sub ListUsers()
'*************************************************************
'* Written By: Davis Chapman
'* Date:       February 12, 2000
'*
'* Syntax:     ListUsers
'*
'* Parameters: None
'*
'* Purpose: This subroutine builds a list of the users in the
'*          specified domain. The list of users is displayed
'*          in the txtResults text box.
'*************************************************************
    Dim myDomain As Object
    Dim objUser As IADsUser
    Dim strMsg As String
    Dim strDomain As String
    
    '--- Build the domain string
    strDomain = "WinNT://" + txtDomain
    '--- Get the domain object
    Set myDomain = GetObject(strDomain)
    '--- Filter for users
    myDomain.Filter = Array("user")
    '--- Initialize the display string
    strMsg = ""
    '--- Loop through the users in the domain
    For Each objUser In myDomain
        '--- Add the current user to the display string
        strMsg = strMsg + objUser.Name + vbCrLf
    Next
    '--- Display the list of users
    txtResults = strMsg
End Sub

Private Sub ListUserGroups()
'*************************************************************
'* Written By: Davis Chapman
'* Date:       February 12, 2000
'*
'* Syntax:     ListUserGroups
'*
'* Parameters: None
'*
'* Purpose: This subroutine builds a list of the users in the
'*          specified domain and the groups in which the users
'*          are members. The list of users is displayed
'*          in the txtResults text box.
'*************************************************************
    Dim myDomain As Object
    Dim objUser As IADsUser
    Dim objGroups As IADsMembers
    Dim objGroup As IADsGroup
    Dim strMsg As String
    Dim strDomain As String
    
    '--- Build the domain string
    strDomain = "WinNT://" + txtDomain
    '--- Get the domain object
    Set myDomain = GetObject(strDomain)
    '--- Filter for users
    myDomain.Filter = Array("user")
    '--- Initialize the display string
    strMsg = ""
    '--- Loop through the users in the domain
    For Each objUser In myDomain
        '--- Add the current user to the display string
        strMsg = strMsg + objUser.Name + vbCrLf
        '--- Get the collection of groups the user is in
        Set objGroups = objUser.Groups
        '--- Loop through the groups the user is a member of
        For Each objGroup In objGroups
            '--- Add the current group to the display string
            strMsg = strMsg + vbTab + objGroup.Name + vbCrLf
        Next
    Next
    '--- Display the list of users
    txtResults = strMsg
End Sub

Private Sub ListGroupUsers()
'*************************************************************
'* Written By: Davis Chapman
'* Date:       February 12, 2000
'*
'* Syntax:     ListGroupUsers
'*
'* Parameters: None
'*
'* Purpose: This subroutine builds a list of the groups in the
'*          specified domain and the users in each group. The
'*          list of groups is displayed in the txtResults text
'*          box.
'*************************************************************
    Dim myDomain As Object
    Dim objGroup As IADsGroup
    Dim objUser As IADsUser
    Dim objUsers As IADsMembers
    Dim strMsg As String
    Dim strDomain As String
    
    On Error Resume Next
    '--- Build the domain string
    strDomain = "WinNT://" + txtDomain
    '--- Get the domain object
    Set myDomain = GetObject(strDomain)
    '--- Filter for groups
    myDomain.Filter = Array("group")
    '--- Initialize the display string
    strMsg = ""
    '--- Loop through the groups in the domain
    For Each objGroup In myDomain
        '--- Add the current user to the display string
        strMsg = strMsg + objGroup.Name + vbCrLf
        '--- Get the collection of users in the group
        Set objUsers = objGroup.Members
        '--- Loop through the users in the group
        For Each objUser In objUsers
            '--- Add the current user to the display string
            strMsg = strMsg + vbTab + objUser.Name + vbCrLf
        Next
    Next
    '--- Display the list of users
    txtResults = strMsg
End Sub

Private Sub cmdList_Click()
'*************************************************************
'* Written By: Davis Chapman
'* Date:       February 12, 2000
'*
'* Syntax:     cmdList_Click
'*
'* Parameters: None
'*
'* Purpose: This subroutine determines which option the user
'*          selected and calls the appropriate subroutine.
'*************************************************************
    '--- Make sure a domain has been specified
    If txtDomain = "" Then
        '--- No domain, tell the user
        MsgBox "You must specify a domain to list the user or group in."
        Exit Sub
    End If
    '--- Which list does the user want?
    Select Case True
        '--- A list of groups
        Case optGroups
            ListGroups
        '--- A list of groups with the users in the groups
        Case optGroupsUsers
            ListGroupUsers
        '--- A list of users
        Case optMembers
            ListUsers
        '--- A list of users with the groups they are in
        Case optMemGroups
            ListUserGroups
    End Select
End Sub
