VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsAuthorize"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Const INVALID_HANDLE_VALUE = -1
Private Const SE_SECURITY_NAME = "SeSecurityPrivilege"
Private Const SE_PRIVILEGE_ENABLED = &H2
Private Const ERROR_INSUFFICIENT_BUFFER = 122

Private Const LMEM_FIXED = &H0
Private Const LMEM_ZEROINIT = &H40
Private Const LPTR = (LMEM_FIXED Or LMEM_ZEROINIT)

Private Const GENERIC_ALL = &H10000000
Private Const ACL_REVISION = (2)

Private Const SECURITY_DESCRIPTOR_MIN_LENGTH = (20)
Private Const SECURITY_DESCRIPTOR_REVISION = (1)

Private Const OWNER_SECURITY_INFORMATION = &H1
Private Const GROUP_SECURITY_INFORMATION = &H2
Private Const DACL_SECURITY_INFORMATION = &H4
Private Const SACL_SECURITY_INFORMATION = &H8

'********************************************
' No longer supported
'********************************************
'Private Const ACTRL_PERM_1 = &H1
'Private Const ACTRL_PERM_2 = &H2
'Private Const ACTRL_PERM_3 = &H4
'Private Const ACTRL_PERM_4 = &H8
'Private Const ACTRL_PERM_5 = &H10
'Private Const ACTRL_PERM_6 = &H20
'Private Const ACTRL_PERM_7 = &H40
'Private Const ACTRL_PERM_8 = &H80
'Private Const ACTRL_PERM_9 = &H100
'Private Const ACTRL_PERM_10 = &H200
'
'Private Const ACTRL_FILE_READ = ACTRL_PERM_1
'Private Const ACTRL_FILE_WRITE = ACTRL_PERM_2
'Private Const ACTRL_FILE_APPEND = ACTRL_PERM_3
'Private Const ACTRL_FILE_READ_PROP = ACTRL_PERM_4
'Private Const ACTRL_FILE_WRITE_PROP = ACTRL_PERM_5
'Private Const ACTRL_FILE_EXECUTE = ACTRL_PERM_6
'Private Const ACTRL_FILE_READ_ATTRIB = ACTRL_PERM_8
'Private Const ACTRL_FILE_WRITE_ATTRIB = ACTRL_PERM_9
'Private Const ACTRL_FILE_CREATE_PIPE = ACTRL_PERM_10

'********************************************
' No longer supported
'********************************************
''
'' Access permissions
''
'Private Const ACTRL_ACCESS_ALLOWED = &H1
'Private Const ACTRL_ACCESS_DENIED = &H2
'Private Const ACTRL_AUDIT_SUCCESS = &H4
'Private Const ACTRL_AUDIT_FAILURE = &H8

Private Const GENERIC_READ = &H80000000
Private Const GENERIC_WRITE = &H40000000
Private Const OPEN_EXISTING = 3
Private Const FILE_ATTRIBUTE_NORMAL = &H80

'
'  The following are masks for the predefined standard access types
'

Private Const DELETE = &H10000
Private Const READ_CONTROL = &H20000
Private Const WRITE_DAC = &H40000
Private Const WRITE_OWNER = &H80000
Private Const SYNCHRONIZE = &H100000

Private Const STANDARD_RIGHTS_REQUIRED = &HF0000

Private Const STANDARD_RIGHTS_READ = READ_CONTROL
Private Const STANDARD_RIGHTS_WRITE = READ_CONTROL
Private Const STANDARD_RIGHTS_EXECUTE = READ_CONTROL

Private Const STANDARD_RIGHTS_ALL = &H1F0000

Private Const SPECIFIC_RIGHTS_ALL = &HFFFF

'
'  The following are the inherit flags that go into the AceFlags field
'  of an Ace header.
'
Private Const OBJECT_INHERIT_ACE = &H1
Private Const CONTAINER_INHERIT_ACE = &H2
Private Const NO_PROPAGATE_INHERIT_ACE = &H4
Private Const INHERIT_ONLY_ACE = &H8
'
' Definition: Inheritance flags
' These bit masks are provided to allow simple application of inheritance in
' explicit access requests on containers.
' NO_INHERITANCE       The specific access permissions will only be applied to
'                  the container, and will not be inherited by objects created
'                  within the container.
' SUB_CONTAINERS_ONLY_INHERIT  The specific access permissions will be inherited
'                              and applied to sub containers created within the
'                              container, and will be applied to the container
'                              itself.
' SUB_OBJECTS_ONLY_INHERIT     The specific access permissions will only be inherited
'                              by objects created within the specific container.
'                              The access permissions will not be applied to the
'                              container itself.
' SUB_CONTAINERS_AND_OBJECTS_INHERIT   The specific access permissions will be
'                                      inherited by containers created within the
'                                      specific container, will be applied to
'                                      objects created within the container, but
'                                      will not be applied to the container itself.
'
Private Const NO_INHERITANCE = &H0
Private Const SUB_OBJECTS_ONLY_INHERIT = &H1
Private Const SUB_CONTAINERS_ONLY_INHERIT = &H2
Private Const SUB_CONTAINERS_AND_OBJECTS_INHERIT = &H3
Private Const INHERIT_NO_PROPAGATE = &H4
Private Const INHERIT_ONLY = &H8

'
' Informational bit that is returned
'
Private Const INHERITED_ACCESS_ENTRY = &H10

'
' Informational bit that tells where a node was inherited from.  Valid only
' for NT 5 APIs
'
Private Const INHERITED_PARENT = &H10000000
Private Const INHERITED_GRANDPARENT = &H20000000

'
' Define access rights to files and directories
'
Private Const FILE_READ_DATA = &H1                   ' file & pipe
Private Const FILE_LIST_DIRECTORY = &H1              ' directory
Private Const FILE_WRITE_DATA = &H2                  ' file & pipe
Private Const FILE_ADD_FILE = &H2                    ' directory
Private Const FILE_APPEND_DATA = &H4                 ' file
Private Const FILE_ADD_SUBDIRECTORY = &H4            ' directory
Private Const FILE_CREATE_PIPE_INSTANCE = &H4        ' named pipe
Private Const FILE_READ_EA = &H8                     ' file & directory
Private Const FILE_WRITE_EA = &H10                   ' file & directory
Private Const FILE_EXECUTE = &H20                    ' file
Private Const FILE_TRAVERSE = &H20                   ' directory
Private Const FILE_DELETE_CHILD = &H40               ' directory
Private Const FILE_READ_ATTRIBUTES = &H80            ' all
Private Const FILE_WRITE_ATTRIBUTES = &H100          ' all
Private Const FILE_ALL_ACCESS = (STANDARD_RIGHTS_REQUIRED Or SYNCHRONIZE Or &H1FF)

Private Const FILE_GENERIC_READ = (STANDARD_RIGHTS_READ Or _
                                   FILE_READ_DATA Or _
                                   FILE_READ_ATTRIBUTES Or _
                                   FILE_READ_EA Or _
                                   SYNCHRONIZE)

Private Const FILE_GENERIC_WRITE = (STANDARD_RIGHTS_WRITE Or _
                                   FILE_WRITE_DATA Or _
                                   FILE_WRITE_ATTRIBUTES Or _
                                   FILE_WRITE_EA Or _
                                   FILE_APPEND_DATA Or _
                                   SYNCHRONIZE)

Private Const FILE_GENERIC_EXECUTE = (STANDARD_RIGHTS_EXECUTE Or _
                                   FILE_READ_ATTRIBUTES Or _
                                   FILE_EXECUTE Or _
                                   SYNCHRONIZE)
                                   
'
' Token Specific Access Rights.
'

Private Const TOKEN_ASSIGN_PRIMARY = &H1
Private Const TOKEN_DUPLICATE = &H2
Private Const TOKEN_IMPERSONATE = &H4
Private Const TOKEN_QUERY = &H8
Private Const TOKEN_QUERY_SOURCE = &H10
Private Const TOKEN_ADJUST_PRIVILEGES = &H20
Private Const TOKEN_ADJUST_GROUPS = &H40
Private Const TOKEN_ADJUST_DEFAULT = &H80
Private Const TOKEN_ADJUST_SESSIONID = &H100

Private Const TOKEN_ALL_ACCESS = (STANDARD_RIGHTS_REQUIRED Or _
                          TOKEN_ASSIGN_PRIMARY Or _
                          TOKEN_DUPLICATE Or _
                          TOKEN_IMPERSONATE Or _
                          TOKEN_QUERY Or _
                          TOKEN_QUERY_SOURCE Or _
                          TOKEN_ADJUST_PRIVILEGES Or _
                          TOKEN_ADJUST_GROUPS Or _
                          TOKEN_ADJUST_SESSIONID Or _
                          TOKEN_ADJUST_DEFAULT)

Enum ACCESS_MODE
    NOT_USED_ACCESS = 0
    GRANT_ACCESS = 1
    SET_ACCESS = 2
    DENY_ACCESS = 3
    REVOKE_ACCESS = 4
    SET_AUDIT_SUCCESS = 5
    SET_AUDIT_FAILURE = 6
End Enum

Enum SID_NAME_USE
    SidTypeUser = 1
    SidTypeGroup = 2
    SidTypeDomain = 3
    SidTypeAlias = 4
    SidTypeWellKnownGroup = 5
    SidTypeDeletedAccount = 6
    SidTypeInvalid = 7
    SidTypeUnknown = 8
    SidTypeComputer = 9
End Enum

Enum SE_OBJECT_TYPE
    SE_UNKNOWN_OBJECT_TYPE = 0
    SE_FILE_OBJECT = 1
    SE_SERVICE = 2
    SE_PRINTER = 3
    SE_REGISTRY_KEY = 4
    SE_LMSHARE = 5
    SE_KERNEL_OBJECT = 6
    SE_WINDOW_OBJECT = 7
    SE_DS_OBJECT = 8
    SE_DS_OBJECT_ALL = 9
    SE_PROVIDER_DEFINED_OBJECT = 10
    SE_WMIGUID_OBJECT = 11
End Enum

Enum ACL_INFORMATION_CLASS
    AclRevisionInformation = 1
    AclSizeInformation = 2
End Enum

Enum TRUSTEE_TYPE
    TRUSTEE_IS_UNKNOWN = 0
    TRUSTEE_IS_USER = 1
    TRUSTEE_IS_GROUP = 2
    TRUSTEE_IS_DOMAIN = 3
    TRUSTEE_IS_ALIAS = 4
    TRUSTEE_IS_WELL_KNOWN_GROUP = 5
    TRUSTEE_IS_DELETED = 6
    TRUSTEE_IS_INVALID = 7
End Enum

Enum TRUSTEE_FORM
    TRUSTEE_IS_SID = 0
    TRUSTEE_IS_NAME = 1
    TRUSTEE_BAD_FORM = 2
End Enum

Enum MULTIPLE_TRUSTEE_OPERATION
    NO_MULTIPLE_TRUSTEE = 0
    TRUSTEE_IS_IMPERSONATE = 1
End Enum

Private Type TRUSTEE
    pMultipleTrustee As Long    'PTRUSTEE
    tMultipleTrusteeOperation As MULTIPLE_TRUSTEE_OPERATION
    tTrusteeForm As TRUSTEE_FORM
    tTrusteeType As TRUSTEE_TYPE
    ptstrName As String
End Type

'********************************************
' No longer supported
'********************************************
Private Type ACTRL_ACCESS_ENTRY
    aaeTrustee As TRUSTEE
    fAccessFlags As Long
    Access As Long
    ProvSpecificAccess As Long
    Inheritance As Long
    lpInheritProperty As String
End Type

Private Type EXPLICIT_ACCESS
    grfAccessPermissions As Long
    grfAccessMode As ACCESS_MODE
    grfInheritance As Long
    eaTrustee As TRUSTEE
End Type

Private Type LARGE_INTEGER
    lowpart As Long
    highpart As Long
End Type

Private Type ACL_SIZE_INFORMATION
        AceCount As Long
        AclBytesInUse As Long
        AclBytesFree As Long
End Type

Private Type LUID
    lowpart As Long
    highpart As Long
End Type

Private Type LUID_AND_ATTRIBUTES
    lLuid As LUID
    Attributes As Long
End Type

Private Type TOKEN_PRIVILEGES
    PrivilegeCount As Long
    Privileges(1) As LUID_AND_ATTRIBUTES
End Type

Private Type SECURITY_ATTRIBUTES
    nLength As Long
    lpSecurityDescriptor As Long    'LPVOID
    bInheritHandle As Long   'BOOL
End Type

Private Type ACL
        AclRevision As Byte
        Sbz1 As Byte
        AclSize As Integer
        AceCount As Integer
        Sbz2 As Integer
End Type

Private Type ACE_HEADER
        AceType As Byte
        AceFlags As Byte
        AceSize As Long
End Type

Private Type ACCESS_ALLOWED_ACE
        Header As ACE_HEADER
        Mask As Long
        SidStart As Long
End Type

Private Type SECURITY_DESCRIPTOR
        Revision As Byte
        Sbz1 As Byte
        Control As Long
        Owner As Long
        Group As Long
        Sacl As ACL
        Dacl As ACL
End Type

'********************************************
' No longer supported
'********************************************
Private Type ACTRL_ACCESS_ENTRY_LIST
    cEntries As Long
    pAccessList As Long   'PACTRL_ACCESS_ENTRY
End Type

'********************************************
' No longer supported
'********************************************
Private Type ACTRL_PROPERTY_ENTRY
    lpProperty As String
    pAccessEntryList As Long  'PACTRL_ACCESS_ENTRY_LIST
    fListFlags As Long
End Type

Private Type ACTRL_ALIST
    cEntries As Long
    pPropertyAccessList As Long  'PACTRL_PROPERTY_ENTRY
End Type

Private Declare Function GetCurrentProcess Lib "kernel32" () As Long

Private Declare Function OpenProcessToken Lib "advapi32.dll" ( _
    ByVal ProcessHandle As Long, _
    ByVal DesiredAccess As Long, _
    TokenHandle As Long) As Long

Private Declare Function LookupPrivilegeValue Lib "advapi32.dll" Alias "LookupPrivilegeValueA" ( _
    ByVal lpSystemName As String, _
    ByVal lpName As String, _
    lpLuid As LUID) As Long

Private Declare Function AdjustTokenPrivileges Lib "advapi32.dll" ( _
    ByVal TokenHandle As Long, _
    ByVal DisableAllPrivileges As Long, _
    NewState As TOKEN_PRIVILEGES, _
    ByVal BufferLength As Long, _
    PreviousState As TOKEN_PRIVILEGES, _
    ReturnLength As Long) As Long

Private Declare Function AdjustTokenPrivileges2 Lib "advapi32.dll" Alias "AdjustTokenPrivileges" ( _
    ByVal TokenHandle As Long, _
    ByVal DisableAllPrivileges As Long, _
    NewState As TOKEN_PRIVILEGES, _
    ByVal BufferLength As Long, _
    PreviousState As Long, _
    ReturnLength As Long) As Long

Private Declare Function LookupAccountName Lib "advapi32.dll" Alias "LookupAccountNameA" ( _
    ByVal lpSystemName As String, _
    ByVal lpAccountName As String, _
    ByVal Sid As Long, _
    cbSid As Long, _
    ByVal ReferencedDomainName As String, _
    cbReferencedDomainName As Long, _
    peUse As SID_NAME_USE) As Long

Private Declare Function LocalAlloc Lib "kernel32" ( _
    ByVal wFlags As Long, _
    ByVal wBytes As Long) As Long

Private Declare Function LocalFree Lib "kernel32" ( _
    ByVal hMem As Long) As Long

Private Declare Function ConvertSidToStringSid Lib "advapi32.dll" Alias "ConvertSidToStringSidA" ( _
    ByVal Sid As Long, _
    StringSid As Long _
    ) As Long

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" ( _
    Destination As Any, _
    ByVal Source As Long, _
    ByVal Length As Long)

Private Declare Function GetAclInformation Lib "advapi32.dll" ( _
    pAcl As ACL, _
    pAclInformation As Any, _
    ByVal nAclInformationLength As Long, _
    ByVal dwAclInformationClass As Integer) As Long

Private Declare Function GetAclInformation2 Lib "advapi32.dll" Alias "GetAclInformation" ( _
    ByVal pAcl As Long, _
    pAclInformation As Any, _
    ByVal nAclInformationLength As Long, _
    ByVal dwAclInformationClass As Integer) As Long

Private Declare Function AddAccessAllowedAceEx Lib "advapi32.dll" ( _
    pAcl As ACL, _
    ByVal dwAceRevision As Long, _
    ByVal AceFlags As Long, _
    ByVal AccessMask As Long, _
    ByVal pSid As Long _
    ) As Long

Private Declare Function AddAccessAllowedAceEx2 Lib "advapi32.dll" ( _
    ByVal pAcl As Long, _
    ByVal dwAceRevision As Long, _
    ByVal AceFlags As Long, _
    ByVal AccessMask As Long, _
    ByVal pSid As Long _
    ) As Long

Private Declare Function InitializeSecurityDescriptor Lib "advapi32.dll" ( _
    pSecurityDescriptor As SECURITY_DESCRIPTOR, _
    ByVal dwRevision As Long) As Long

Private Declare Function InitializeSecurityDescriptor2 Lib "advapi32.dll" Alias "InitializeSecurityDescriptor" ( _
    ByVal pSecurityDescriptor As Long, _
    ByVal dwRevision As Long) As Long

Private Declare Function IsValidSid Lib "advapi32.dll" ( _
    ByVal pSid As Long) As Long

Private Declare Function GetLengthSid Lib "advapi32.dll" ( _
    ByVal pSid As Long) As Long

Private Declare Function SetSecurityDescriptorDacl Lib "advapi32.dll" ( _
    ByVal pSecurityDescriptor As Long, _
    ByVal bDaclPresent As Long, _
    ByVal pDacl As Long, _
    ByVal bDaclDefaulted As Long) As Long

Private Declare Function InitializeAcl Lib "advapi32.dll" ( _
    ByVal pAcl As Long, ByVal nAclLength As Long, _
    ByVal dwAclRevision As Long) As Long

Private Declare Function GetNamedSecurityInfo Lib "advapi32.dll" Alias "GetNamedSecurityInfoA" ( _
    ByVal pObjectName As String, _
    ByVal ObjectType As SE_OBJECT_TYPE, _
    ByVal SecurityInfo As Long, _
    ppsidOwner As Long, _
    ppsidGroup As Long, _
    ppDacl As Long, _
    ppSacl As Long, _
    ppSecurityDescriptor As Long _
    ) As Long

Private Declare Sub BuildTrusteeWithName Lib "advapi32.dll" Alias "BuildTrusteeWithNameA" ( _
    pTrustee As Any, _
    ByVal pName As String _
    )

Private Declare Sub BuildTrusteeWithName2 Lib "advapi32.dll" Alias "BuildTrusteeWithNameA" ( _
    ByVal pTrustee As Long, _
    ByVal pName As String _
    )

Private Declare Sub ZeroMemory Lib "kernel32" Alias "RtlZeroMemory" ( _
    dest As Any, _
    ByVal numBytes As Long)

'********************************************
' No longer supported
'********************************************
Private Declare Function SetEntriesInAccessList Lib "advapi32.dll" Alias "SetEntriesInAccessListA" ( _
    ByVal cEntries As Long, _
    pAccessEntryList As ACTRL_ACCESS_ENTRY, _
    ByVal AccessMode As ACCESS_MODE, _
    ByVal lpProperty As String, _
    pOldList As ACTRL_ALIST, _
    ppNewList As Long _
    ) As Long

'********************************************
' No longer supported
'********************************************
Private Declare Function SetEntriesInAccessList2 Lib "advapi32.dll" Alias "SetEntriesInAccessListA" ( _
    ByVal cEntries As Long, _
    pAccessEntryList As ACTRL_ACCESS_ENTRY, _
    ByVal AccessMode As ACCESS_MODE, _
    ByVal lpProperty As Long, _
    ByVal pOldList As Long, _
    ppNewList As Long _
    ) As Long

'********************************************
' No longer supported
'********************************************
Private Declare Function ConvertAccessToSecurityDescriptor Lib "advapi32.dll" Alias "ConvertAccessToSecurityDescriptorA" ( _
    pAccessList As ACTRL_ALIST, _
    pAuditList As ACTRL_ALIST, _
    ByVal lpOwner As String, _
    ByVal lpGroup As String, _
    ppSecDescriptor As Long _
    ) As Long

'********************************************
' No longer supported
'********************************************
Private Declare Function ConvertAccessToSecurityDescriptor2 Lib "advapi32.dll" Alias "ConvertAccessToSecurityDescriptorA" ( _
    ByVal pAccessList As Long, _
    ByVal pAuditList As Long, _
    ByVal lpOwner As Long, _
    ByVal lpGroup As Long, _
    ppSecDescriptor As Long _
    ) As Long

Private Declare Function SetEntriesInAcl Lib "advapi32.dll" Alias "SetEntriesInAclA" ( _
    ByVal cCountOfExplicitEntries As Long, _
    pListOfExplicitEntries As EXPLICIT_ACCESS, _
    OldAcl As ACL, _
    NewAcl As Long _
    ) As Long

Private Declare Function SetEntriesInAcl2 Lib "advapi32.dll" Alias "SetEntriesInAclA" ( _
    ByVal cCountOfExplicitEntries As Long, _
    pListOfExplicitEntries As EXPLICIT_ACCESS, _
    ByVal OldAcl As Long, _
    NewAcl As Long _
    ) As Long

Private Declare Function ImpersonateNamedPipeClient Lib "advapi32.dll" ( _
    ByVal hNamedPipe As Long) As Long

Private Declare Function ImpersonateLoggedOnUser Lib "advapi32.dll" ( _
    ByVal hToken As Long) As Long

Private Declare Function RevertToSelf Lib "advapi32.dll" () As Long

Private Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" ( _
    ByVal lpFileName As String, _
    ByVal dwDesiredAccess As Long, _
    ByVal dwShareMode As Long, _
    lpSecurityAttributes As SECURITY_ATTRIBUTES, _
    ByVal dwCreationDisposition As Long, _
    ByVal dwFlagsAndAttributes As Long, _
    ByVal hTemplateFile As Long) As Long
    
Private Declare Function CreateFile2 Lib "kernel32" Alias "CreateFileA" ( _
    ByVal lpFileName As String, _
    ByVal dwDesiredAccess As Long, _
    ByVal dwShareMode As Long, _
    ByVal lpSecurityAttributes As Long, _
    ByVal dwCreationDisposition As Long, _
    ByVal dwFlagsAndAttributes As Long, _
    ByVal hTemplateFile As Long) As Long
    
Private Declare Function CloseHandle Lib "kernel32" ( _
    ByVal hObject As Long) As Long

Public Function EnableSecurityNamePrivilege(bEnable As Boolean) As Boolean
'*************************************************************
'* Written By: Mickey Williams/Davis Chapman
'* Date:       January 29, 2000
'*
'* Syntax:     EnableSecurityNamePrivilege(bEnable)
'*
'* Parameters: bEnable As Boolean
'*
'* Purpose: Enables or disables the SE_SECURITY_NAME privilege for the
'*          current process.  This privilege must be explicitly enabled
'*          to access some security information. Returns FALSE
'*          if the privilege was adjusted, or TRUE otherwise.
'*************************************************************

    EnableSecurityNamePrivilege = False
    
    Dim hProcess As Long
    Dim hToken As Long
    Dim tpNew As TOKEN_PRIVILEGES
    Dim bLookup As Boolean
    Dim strSysName As String
    Dim bAdjusted As Boolean
    
    '--- Get the handle of the current process
    hProcess = GetCurrentProcess

    '--- Open a token for the process
    If (Not CBool(OpenProcessToken(hProcess, TOKEN_ALL_ACCESS, hToken))) Then
        Exit Function
    End If
    
    '--- Lookup the security name privilege value for the current process
    strSysName = vbNullChar
    bLookup = CBool(LookupPrivilegeValue(strSysName, _
                                        SE_SECURITY_NAME, _
                                        tpNew.Privileges(0).lLuid))
    '--- If unable to lookup the value, exit
    If (Not bLookup) Then Exit Function

    '--- Is the security name priviledge to be enabled or disabled?
    If (bEnable) Then
        '--- Enable
        tpNew.Privileges(0).Attributes = SE_PRIVILEGE_ENABLED
    Else
        '--- Disable
        tpNew.Privileges(0).Attributes = 0
    End If
    
    '--- Set the privilege count
    tpNew.PrivilegeCount = 1

    '--- Adjust the process privilege
    bAdjusted = CBool(AdjustTokenPrivileges2(hToken, _
                                           0, _
                                           tpNew, _
                                           0, _
                                           0, _
                                           0))
    '--- If unable to adjust the privilege, exit
    If (Not bAdjusted) Then Exit Function
    
    '--- Set the return value to true
    EnableSecurityNamePrivilege = True

End Function


Public Sub AccountNameToSidString(lpszSystem As String, _
                            lpszAccountName As String, _
                            pszSidBuffer As String, _
                            cbSidBuffer As Long)
'*************************************************************
'* Written By: Mickey Williams/Davis Chapman
'* Date:       January 29, 2000
'*
'* Syntax:     AccountNameToSidString(lpszSystem, lpszAccountName,
'*                          pszSidBuffer, cbSidBuffer)
'*
'* Parameters: lpszSystem As String
'*             lpszAccountName As String
'*             pszSidBuffer As String
'*             cbSidBuffer As Long
'*
'* Purpose: Gets the SID for the specified account name, then
'*          converts it into a string and returns it.
'*************************************************************
    Dim pSid As Long  'PSID
    Dim cbSid As Long
    Dim lpszRefDomain As String * 256
    Dim cbRefDomain As Long
    Dim sne As SID_NAME_USE
    Dim bRet As Boolean
    Dim dwErr As Long
    Dim pszSidString As Long 'LPTSTR
    
    '--- Initialize the variables
    pSid = 0
    cbSid = 0
    cbRefDomain = 256

    '--- Lookup the account name
    bRet = CBool(LookupAccountName(lpszSystem, _
                                  lpszAccountName, _
                                  pSid, _
                                  cbSid, _
                                  lpszRefDomain, _
                                  cbRefDomain, _
                                  sne))
    '--- First call is expected to fail
    If (bRet <> False) Then
        MsgBox "LookupAccountName returned invalid val"
        Exit Sub
    End If
    '--- Check the error
    dwErr = Err.LastDllError
    '--- If ERROR_INSUFFICIENT_BUFFER then allocate the buffer
    If (dwErr = ERROR_INSUFFICIENT_BUFFER) Then
        pSid = LocalAlloc(LPTR, cbSid)
        If (pSid = 0) Then
            MsgBox "LocalAlloc for SID failed"
            Exit Sub
        End If
        '--- Lookup the account name again
        bRet = CBool(LookupAccountName(lpszSystem, _
                                 lpszAccountName, _
                                 pSid, _
                                 cbSid, _
                                 lpszRefDomain, _
                                 cbRefDomain, _
                                 sne))
        '--- If we failed this time, then we really failed
        If (bRet = False) Then
            MsgBox "LookupAccountName #2 failed"
            '--- Free the buffer
            LocalFree pSid
            Exit Sub
        End If
    Else
        MsgBox "GetLastError returned invalid val"
        Exit Sub
    End If

    '--- Initialize the SID string
    pszSidString = 0

    '--- Convert the SID to a string
    bRet = CBool(ConvertSidToStringSid(pSid, pszSidString))
    '--- Allocate the string to copy the SID string into
    pszSidBuffer = String(cbSidBuffer + 1, vbNullChar)
    '--- Copy the SID string
    CopyMemory ByVal pszSidBuffer, pszSidString, cbSidBuffer
    '--- Free the allocated buffers
    LocalFree pszSidString
    LocalFree pSid
End Sub

Public Function AccountNameToSid(lpszAccountName As String) As Long
'*************************************************************
'* Written By: Mickey Williams/Davis Chapman
'* Date:       January 29, 2000
'*
'* Syntax:     AccountNameToSid(lpszAccountName)
'*
'* Parameters: lpszAccountName As String
'*
'* Purpose: Gets and returns the SID for the specified account
'*          name.
'*************************************************************
    Dim pSid As Long
    Dim cbSid As Long
    Dim lpszRefDomain As String * 256
    Dim cbRefDomain As Long
    Dim sne As SID_NAME_USE
    Dim bRet As Boolean
    Dim dwErr As Long
    
    '--- Initialize the variables
    pSid = 0
    cbSid = 0
    cbRefDomain = 256

    '--- Lookup the account name
    bRet = CBool(LookupAccountName(vbNullString, _
                                  lpszAccountName, _
                                  pSid, _
                                  cbSid, _
                                  lpszRefDomain, _
                                  cbRefDomain, _
                                  sne))
    '--- First call is expected to fail
    If (bRet <> False) Then
        AccountNameToSid = 0
        Exit Function
    End If
    '--- Check the error
    dwErr = Err.LastDllError
    '--- If ERROR_INSUFFICIENT_BUFFER then allocate the buffer
    If (dwErr = ERROR_INSUFFICIENT_BUFFER) Then
        pSid = LocalAlloc(LPTR, cbSid)
        If (pSid = 0) Then
            AccountNameToSid = 0
            Exit Function
        End If
        '--- Lookup the account name again
        bRet = CBool(LookupAccountName(vbNullString, _
                                 lpszAccountName, _
                                 pSid, _
                                 cbSid, _
                                 lpszRefDomain, _
                                 cbRefDomain, _
                                 sne))
        '--- If we failed this time, then we really failed
        If (bRet = False) Then
            '--- Free the buffer
            LocalFree pSid
            AccountNameToSid = 0
            Exit Function
        End If
    Else
        AccountNameToSid = 0
        Exit Function
    End If
    '--- Return the pointer to the SID
    AccountNameToSid = pSid
End Function

Public Function GetAclSize(pAcl As Long, pdw As Long) As Boolean
'*************************************************************
'* Written By: Mickey Williams/Davis Chapman
'* Date:       January 29, 2000
'*
'* Syntax:     GetAclSize(pAcl, pdw)
'*
'* Parameters: pAcl As Long
'*             pdw As Long
'*
'* Purpose: Gets the current size of an ACL.
'*************************************************************
    Dim info As ACL_SIZE_INFORMATION
    Dim bInfo As Boolean
    
    '--- Get the size information on the ACL
    bInfo = CBool(GetAclInformation2(pAcl, _
                                   info, _
                                   12, _
                                   AclSizeInformation))
    '--- Did we get the info?
    If (bInfo) Then
        '--- Get the size of the ACL
        pdw = info.AclBytesInUse
    End If
    '--- Return whether we succeeded or failed
    GetAclSize = bInfo
End Function

Public Function AllowUserAccessThroughAcl(pAcl As Long, lpszUser As String) As Boolean
'*************************************************************
'* Written By: Mickey Williams/Davis Chapman
'* Date:       January 29, 2000
'*
'* Syntax:     AllowUserAccessThroughAcl(pAcl, lpszUser)
'*
'* Parameters: pAcl As Long
'*             lpszUser As String
'*
'* Purpose: Modifies an ACL to allow the specified user access
'*          to whatever it is that the ACL controls.
'*************************************************************
    Dim pSid As Long
    Dim bAdded As Boolean
    
    '--- Get a pointer to the SID for this user
    pSid = AccountNameToSid(lpszUser)
    '--- Did we get a SID pointer?
    If (Not pSid) Then
        '--- No, return a failure
        AllowUserAccessThroughAcl = False
        Exit Function
    End If

    '--- Add the SID to the access list for the ACL
    bAdded = CBool(AddAccessAllowedAceEx2(pAcl, _
                                        ACL_REVISION, _
                                        0, _
                                        GENERIC_ALL, _
                                        pSid))
    '--- Free the SID
    LocalFree pSid
    '--- Return whether the SID was added to the ACL
    AllowUserAccessThroughAcl = bAdded
End Function


Public Function CreateEmptySecurityDescriptor() As Long
'*************************************************************
'* Written By: Mickey Williams/Davis Chapman
'* Date:       January 29, 2000
'*
'* Syntax:     CreateEmptySecurityDescriptor
'*
'* Parameters: None
'*
'* Purpose: Creates and returns a pointer to an empty security
'*          descriptor.
'*************************************************************
    Dim psd As Long
    Dim bInit As Boolean
    
    '--- Initialize the pointer to the security descriptor buffer
    psd = 0

    '--- Allocate the security descriptor buffer
    psd = LocalAlloc(LPTR, SECURITY_DESCRIPTOR_MIN_LENGTH)
    '--- Did we allocate the buffer?
    If (psd <> 0) Then
        '--- Yes, initialize the security descriptor
        bInit = CBool(InitializeSecurityDescriptor2(psd, _
                                     SECURITY_DESCRIPTOR_REVISION))
        '--- Did we initialize it?
        If (Not bInit) Then
            '--- No, free the buffer and reset the pointer
            LocalFree psd
            psd = 0
        End If
    End If
    '--- Return the pointer
    CreateEmptySecurityDescriptor = psd
End Function


Public Function CreateAllowedSDForUser(lpszUser As String) As Long
'*************************************************************
'* Written By: Mickey Williams/Davis Chapman
'* Date:       January 29, 2000
'*
'* Syntax:     CreateAllowedSDForUser(lpszUser)
'*
'* Parameters: lpszUser As String
'*
'* Purpose: Creates an access allowed security descriptor for
'*          the specified user. The pointer to the security
'*          descriptor that is created is returned.
'*************************************************************
    Dim psd As Long
    Dim pSid As Long
    Dim cbSid As Long
    Dim pAcl As Long
    Dim cbAcl As Long
    Dim bAdded As Boolean
    Dim bInitialized As Boolean
    
    '--- Initialize the pointer
    psd = 0

    '--- Create the empty security descriptor
    psd = CreateEmptySecurityDescriptor
    '--- If unable to create the security descriptor, return a NULL pointer
    If (psd = 0) Then
        CreateAllowedSDForUser = 0
        Exit Function
    End If

    '--- Convert the account name to a SID
    pSid = AccountNameToSid(lpszUser)
    '--- Did we get a SID?
    If ((pSid = 0) Or Not CBool(IsValidSid(pSid))) Then
        '--- No, free the SID and security descriptors
        LocalFree pSid
        LocalFree psd
        '--- Return a NULL pointer
        CreateAllowedSDForUser = 0
        Exit Function
    End If

    '--- Get the length of the SID
    cbSid = GetLengthSid(pSid)
    '--- Calculate the required size for the ACL
    pAcl = 0
    cbAcl = 8 + 14 + cbSid
    '--- Allocate the ACL
    pAcl = LocalAlloc(LPTR, cbAcl)

    '--- Initialize the Acl
    bInitialized = InitializeAcl(pAcl, cbAcl, ACL_REVISION)
    
    '--- Add the SID to the ACL
    bAdded = CBool(AddAccessAllowedAceEx2(pAcl, _
                                        ACL_REVISION, _
                                        0, _
                                        GENERIC_ALL, _
                                        pSid))
    '--- Free the SID
    LocalFree pSid
    '--- Set the ACL for the security descriptor
    bAdded = CBool(SetSecurityDescriptorDacl(psd, -1, pAcl, 0))

    '--- Return the pointer for the security descriptor
    CreateAllowedSDForUser = psd
End Function


Public Function GetFileSecurityDescriptor(pszPath As String) As Long
'*************************************************************
'* Written By: Mickey Williams/Davis Chapman
'* Date:       January 29, 2000
'*
'* Syntax:     GetFileSecurityDescriptor(pszPath)
'*
'* Parameters: pszPath As String
'*
'* Purpose: Returns a pointer to the security descriptor for
'*          the specified file.
'*************************************************************
    Dim psidOwner As Long  'PSID
    Dim psidGroup As Long  'PSID
    Dim pAcl As Long   'PACL
    Dim pSacl As Long   'PACL
    Dim psd As Long    'PSECURITY_DESCRIPTOR
    Dim lRtn As Long
    
    '--- Initialize the pointers
    psidOwner = 0
    psidGroup = 0
    pAcl = 0
    pSacl = 0
    psd = 0

    '--- Get the security information for the file
    lRtn = GetNamedSecurityInfo(pszPath, _
                         SE_FILE_OBJECT, _
                         (OWNER_SECURITY_INFORMATION Or _
                         GROUP_SECURITY_INFORMATION Or _
                         DACL_SECURITY_INFORMATION), _
                         psidOwner, _
                         psidGroup, _
                         pAcl, _
                         pSacl, _
                         psd)
    '--- Return the pointer for the security descriptor
    '--- This pointer will need to be released
    '--- using the LocalFree function
    GetFileSecurityDescriptor = psd
End Function


Public Sub BuildBadTrusteeStruct(pTrustee As Long)
'*************************************************************
'* Written By: Mickey Williams/Davis Chapman
'* Date:       January 29, 2000
'*
'* Syntax:     BuildBadTrusteeStruct(pTrustee)
'*
'* Parameters: pTrustee As Long
'*
'* Purpose: Create a TRUSTEE type structure for a non-existant
'*          user account.
'*************************************************************
    Dim lTempString As String
    
    '--- Create a nonexistent username string
    lTempString = "chaperada\harvey"
    '--- Get a pointer to the TRUSTEE type structure
    BuildTrusteeWithName2 pTrustee, lTempString
End Sub

Public Sub FillAccessEntry(pae As Long, pszName As String)
'*************************************************************
'* Written By: Mickey Williams/Davis Chapman
'* Date:       January 29, 2000
'*
'* Syntax:     FillAccessEntry(pae, pszName)
'*
'* Parameters: pae As Long
'*             pszName As String
'*
'* Purpose: Initialize an EXPLICIT_ACCESS type structure with
'*          generic access values.
'*************************************************************
    Dim aaePae As EXPLICIT_ACCESS
    
    '--- Clear the memory for the structure
    ZeroMemory aaePae, 32
    '--- Create the TRUSTEE type structure
    BuildTrusteeWithName aaePae.eaTrustee, pszName

    '--- Specify the security values
    aaePae.grfInheritance = NO_INHERITANCE
    aaePae.grfAccessMode = GRANT_ACCESS
    aaePae.grfAccessPermissions = (FILE_WRITE_DATA Or FILE_READ_DATA Or _
                  FILE_EXECUTE Or FILE_APPEND_DATA Or _
                  FILE_READ_ATTRIBUTES Or FILE_WRITE_ATTRIBUTES Or _
                  FILE_READ_EA Or FILE_WRITE_EA)
    '--- Copy the type structure back to the pointer
    CopyMemory ByVal pae, VarPtr(aaePae), 32
End Sub

Public Function CreateAntiAuthorSecurityDescriptor() As Long
'*************************************************************
'* Written By: Mickey Williams/Davis Chapman
'* Date:       January 29, 2000
'*
'* Syntax:     CreateAntiAuthorSecurityDescriptor
'*
'* Parameters: None
'*
'* Purpose: Create a security descriptor that restricts the author from
'*          accessing an object. The caller must use LocalFree to release
'*          the memory used by the security descriptor.
'*************************************************************

    Dim ae As EXPLICIT_ACCESS
    Dim pal As Long    'PACL
    Dim dwErr As Long
    
    '--- Initialize the pointer
    pal = 0
    dwErr = 0

On Error GoTo CreateAntiAuthorSecurityDescriptor_Err
    '--- Clear the memory for the structure
    ZeroMemory ae, 32
    '--- Create the TRUSTEE type structure
    BuildTrusteeWithName ae.eaTrustee, "chaperada\davis"

    '--- Specify the security values
    ae.grfInheritance = NO_INHERITANCE
    ae.grfAccessPermissions = STANDARD_RIGHTS_ALL
    ae.grfAccessMode = DENY_ACCESS
    '--- Create an ACL with these permissions
    dwErr = SetEntriesInAcl2(1, ae, 0, pal)
CreateAntiAuthorSecurityDescriptor_Err:
    '--- Did we have an error?
    If (dwErr <> 0) Then
        MsgBox "Security Error"
    End If
    '--- Return the pointer to the ACL
    CreateAntiAuthorSecurityDescriptor = pal
End Function

Public Function TestFileForAccess(hUser As Long, szFileName As String) As Boolean
'*************************************************************
'* Written By: Mickey Williams/Davis Chapman
'* Date:       January 29, 2000
'*
'* Syntax:     TestFileForAccess(hUser, szFileName)
'*
'* Parameters: hUser As Long
'*             szFileName As String
'*
'* Purpose: Impersonate the logged in user and try to open the
'*          specified file to see if the user has access to the
'*          file.
'*************************************************************
    Dim hFile As Long
    Dim bAllowed As Boolean
    
    On Error GoTo TestFileForAccess_Err
    '--- Initialize the return value
    bAllowed = False

    '--- impersonate the client
    ImpersonateLoggedOnUser hUser

    '--- Open file for reading and writing
    hFile = FreeFile
    Open szFileName For Random Access Read Write As hFile
    '--- Able to open the file, change the return value
    bAllowed = True
    '--- Close the file
    Close hFile
    
TestFileForAccess_Err:
    '--- Revert to primary access token
    RevertToSelf
    TestFileForAccess = bAllowed
End Function
