VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 1  'NoTransaction
END
Attribute VB_Name = "clsServer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Public Function GetRecordset(astrRow1String As String, _
                    Optional astrRow2String As String = "") As Object
'*************************************************************
'* Written By: Davis Chapman
'* Date:       January 16, 2000
'*
'* Syntax:      GetRecordset(astrRow1String[, astrRow2String])
'*
'* Parameters:   astrRow1String As String
'*              astrRow2String As String
'*
'* Purpose: This will take one or two strings and create a
'*          recordset, using the strings passed in as row names,
'*          generates random values for the row value, and gets
'*          the current time for the row time. The recordset
'*          is then returned to the calling application.
'*************************************************************
    '--- Create a new recordset
    Dim objRtnRS As New ADODB.Recordset
On Error GoTo GetRecordset_Err
    
    '--- Build and initialize the return recordset
    objRtnRS.Fields.Append "RowName", adBSTR
    objRtnRS.Fields.Append "RowValue", adInteger
    objRtnRS.Fields.Append "RowTime", adDate
    '--- Open the recordset
    objRtnRS.Open
    '--- Add first row
    objRtnRS.AddNew
    '--- Populate the row values
    objRtnRS("RowName") = astrRow1String
    objRtnRS("RowValue") = ((50 * Rnd) + 1)
    objRtnRS("RowTime") = Now
    '--- Do we need to add a second row?
    If astrRow2String <> "" Then
        '--- Add second row
        objRtnRS.AddNew
        '--- Populate the row values
        objRtnRS("RowName") = astrRow2String
        objRtnRS("RowValue") = ((50 * Rnd) + 1)
        objRtnRS("RowTime") = Now
    End If
    '--- Set the return value to the recordset
    Set GetRecordset = objRtnRS
    '--- Exit the function
    Exit Function
    
GetRecordset_Err:
    '--- An error occurred, log the error
    App.LogEvent "GetRecordset Error = " & Err.Number & " = " & Err.Description
    '--- Exit the function
    Exit Function
End Function

Public Function GetString(Optional aiValue As Integer = 0) As String
'*************************************************************
'* Written By: Davis Chapman
'* Date:       January 16, 2000
'*
'* Syntax:      GetString([aiValue])
'*
'* Parameters:   aiValue As Integer
'*
'* Purpose: This will build a string that specifies what the
'*          numeric value that was passed in is. The string
'*          that was built is returned.
'*************************************************************
    Dim strRtnValue As String
On Error GoTo GetString_Err

    '--- Initialize the return value
    GetString = ""
    
    '--- Was a non-zero value passed in?
    If aiValue <> 0 Then
        '--- Yes, build a return string specifying the value
        strRtnValue = "The value passed is " + CStr(aiValue) + "."
    Else
        '--- No, build a return string stating that no value was passed
        strRtnValue = "There was no value passed, or the value was 0."
    End If
    '--- Return the string
    GetString = strRtnValue
    '--- Exit the function
    Exit Function
    
GetString_Err:
    '--- An error occurred, log the error
    App.LogEvent "GetString Error = " & Err.Number & " = " & Err.Description
    '--- Exit the function
    Exit Function
End Function

Public Function GetBoolean(astrFirstValue As String, _
                            astrSecondValue As String) As Boolean
'*************************************************************
'* Written By: Davis Chapman
'* Date:       January 16, 2000
'*
'* Syntax:      GetBoolean(astrFirstValue, astrSecondValue)
'*
'* Parameters:   astrFirstValue As String
'*              astrSecondValue As String
'*
'* Purpose: This will compare the two strings passed in, compare
'*          them, and return a boolean specifying whether or
'*          not they match.
'*************************************************************
On Error GoTo GetBoolean_Err

    '--- Initialize the return value to FALSE
    GetBoolean = False
    
    '--- If the two strings match, change the return value to TRUE
    If (astrFirstValue = astrSecondValue) Then GetBoolean = True
    '--- Exit the function
    Exit Function
    
GetBoolean_Err:
    '--- An error occurred, log the error
    App.LogEvent "GetBoolean Error = " & Err.Number & " = " & Err.Description
    '--- Exit the function
    Exit Function
End Function

Private Sub Class_Initialize()
    '--- Initialize the random number generator
    Randomize
End Sub

