VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "Comdlg32.OCX"
Begin VB.Form frmFileEncrypt 
   Caption         =   "File Encryption"
   ClientHeight    =   1665
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5970
   LinkTopic       =   "Form1"
   ScaleHeight     =   1665
   ScaleWidth      =   5970
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdExit 
      Cancel          =   -1  'True
      Caption         =   "E&xit"
      Height          =   315
      Left            =   4920
      TabIndex        =   7
      Top             =   1260
      Width           =   915
   End
   Begin VB.CommandButton cmdDecrypt 
      Caption         =   "&Decrypt"
      Height          =   315
      Left            =   1500
      TabIndex        =   6
      Top             =   1260
      Width           =   915
   End
   Begin VB.CommandButton cmdEncrypt 
      Caption         =   "&Encrypt"
      Height          =   315
      Left            =   1500
      TabIndex        =   5
      Top             =   900
      Width           =   915
   End
   Begin VB.TextBox txtPassword 
      Height          =   315
      Left            =   1500
      TabIndex        =   4
      Top             =   480
      Width           =   3255
   End
   Begin MSComDlg.CommonDialog cdFile 
      Left            =   5280
      Top             =   600
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.CommandButton cmdBrowse 
      Caption         =   "&Browse"
      Height          =   315
      Left            =   4920
      TabIndex        =   2
      Top             =   120
      Width           =   915
   End
   Begin VB.TextBox txtFileName 
      Height          =   315
      Left            =   1500
      TabIndex        =   1
      Top             =   120
      Width           =   3255
   End
   Begin VB.Label Label2 
      Caption         =   "Password:"
      Height          =   255
      Left            =   120
      TabIndex        =   3
      Top             =   480
      Width           =   1275
   End
   Begin VB.Label Label1 
      Caption         =   "File To Encrypt:"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1275
   End
End
Attribute VB_Name = "frmFileEncrypt"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub DoEncrypt()
'*************************************************************
'* Written By: Davis Chapman
'* Date:       September 06, 1999
'*
'* Syntax:     DoEncrypt
'*
'* Parameters:  None
'*
'* Purpose: This subroutine creates an instance of the Crypto
'*          class, copies the password and file data to the
'*          password and input buffer properties of the class,
'*          and then performs the encryption in three steps.
'*          First, it creates a session key from the password.
'*          Second, it encrypts the message using the session
'*          key. Third, it destroys the session key. Finally,
'*          the encrypted message is copied from the output
'*          buffer property to the original file.
'*************************************************************
    '-- Create an instance of the encryption class
    Dim csCrypt As New clsCrypto
    Dim strFile As String
    Dim lFileLength As Long
    
    '-- Get the length of the file to be decrypted
    lFileLength = FileLen(txtFileName.Text)
    
    '-- Allocate the string to hold the entire file
    strFile = String(lFileLength, vbNullChar)
    
    '-- Open the file in binary mode
    Open txtFileName.Text For Binary Access Read As #1
    
    '-- Read in the file
    Get 1, , strFile
    
    '-- Close the file
    Close #1
    
    '-- Set the password and input buffer properties
    csCrypt.Password = txtPassword.Text
    csCrypt.InBuffer = strFile
    
    '-- Generate a hash of the original file
    If Not csCrypt.HashFile Then _
        Exit Sub
        
    '-- Generate the password based session key
    If Not csCrypt.GeneratePasswordKey Then _
        Exit Sub
        
    '-- Encrypt the message data
    If Not csCrypt.EncryptFileData Then _
        Exit Sub
            
    '-- Destroy the session key
    csCrypt.DestroySessionKey
    
    '-- Do we have valid data to write back to the file?
    If csCrypt.OutBuffer <> "" Then
    
        '-- Delete the current file
        Kill txtFileName.Text
        
        '-- Open the file for writing in binary mode
        Open txtFileName.Text For Binary Access Write As #1
        
        '-- Write out the file
        Put 1, , csCrypt.OutBuffer
        
        '-- Close the file
        Close #1
    
    End If
End Sub

Private Sub DoDecrypt()
'*************************************************************
'* Written By: Davis Chapman
'* Date:       September 06, 1999
'*
'* Syntax:     DoDecrypt
'*
'* Parameters:  None
'*
'* Purpose: This subroutine creates an instance of the Crypto
'*          class, copies the password and encrypted file to the
'*          password and input buffer properties of the class,
'*          and then performs the decryption in three steps.
'*          First, it creates a session key from the password.
'*          Second, it decrypts the message using the session
'*          key. Third, it destroys the session key. Finally,
'*          the decrypted message is copied from the output
'*          buffer property to the original file.
'*************************************************************
    '-- Create an instance of the encryption class
    Dim csCrypt As New clsCrypto
    Dim strFile As String
    Dim lFileLength As Long
    
    '-- Get the length of the file to be decrypted
    lFileLength = FileLen(txtFileName.Text)
    
    '-- Allocate the string to hold the entire file
    strFile = String(lFileLength, vbNullChar)
    
    '-- Open the file in binary mode
    Open txtFileName.Text For Binary Access Read As #1
    
    '-- Read in the file
    Get 1, , strFile
    
    '-- Close the file
    Close #1
    
    '-- Set the password and input buffer properties
    csCrypt.Password = txtPassword.Text
    csCrypt.InBuffer = strFile
    
    '-- Generate the password based session key
    If Not csCrypt.GeneratePasswordKey Then _
        Exit Sub
    
    '-- Decrypt the message data
    If Not csCrypt.DecryptFileData Then _
        Exit Sub
        
    '-- Destroy the session key
    csCrypt.DestroySessionKey
    
    '-- Do we have valid data to write back to the file?
    If csCrypt.OutBuffer <> "" Then
    
        '-- Delete the current file
        Kill txtFileName.Text
        
        '-- Open the file for writing in binary mode
        Open txtFileName.Text For Binary Access Write As #1
        
        '-- Write out the file
        Put 1, , csCrypt.OutBuffer
        
        '-- Close the file
        Close #1
    End If

End Sub

Private Sub cmdBrowse_Click()
    cdFile.Filter = "Text File|*.txt|All Files|*.*"
    cdFile.ShowOpen
    txtFileName.Text = cdFile.FileName
End Sub

Private Sub cmdDecrypt_Click()
'*************************************************************
'* Written By: Davis Chapman
'* Date:       September 06, 1999
'*
'* Syntax:     cmdDecrypt_Click
'*
'* Parameters:  None
'*
'* Purpose: This function is called when the user clicks the
'*          Decrypt button. It checks to make sure that the
'*          user has entered a password and that there is
'*          encrypted data to be decrypted. It then calls the
'*          DoDecrypt subroutine.
'*************************************************************
    '-- Do we have a password?
    If txtPassword.Text = "" Then
        MsgBox "You must provide a password to use for encrypting the message."
        txtPassword.SetFocus
        
    '-- Do we have encrypted data?
    ElseIf txtFileName.Text = "" Then
        MsgBox "You must specify a file to be decrypted."
        txtFileName.SetFocus
    
    '-- We can perform the decryption
    Else
        DoDecrypt
    End If
End Sub

Private Sub cmdEncrypt_Click()
'*************************************************************
'* Written By: Davis Chapman
'* Date:       September 06, 1999
'*
'* Syntax:     cmdEncrypt_Click
'*
'* Parameters:  None
'*
'* Purpose: This function is called when the user clicks the
'*          Encrypt button. It checks to make sure that the
'*          user has entered a password and that there is
'*          message data to be encrypted. It then calls the
'*          DoEncrypt subroutine.
'*************************************************************
    '-- Do we have a password?
    If txtPassword.Text = "" Then
        MsgBox "You must provide a password to use for encrypting the message."
        txtPassword.SetFocus
    
    '-- Do we have message data?
    ElseIf txtFileName.Text = "" Then
        MsgBox "You must specify a file to be encrypted."
        txtFileName.SetFocus
    
    '-- We can perform the encryption
    Else
        DoEncrypt
    End If
End Sub

Private Sub cmdExit_Click()
    '-- Exit the application
    Unload Me
End Sub
