VERSION 5.00
Begin VB.Form frmSimpleEncrypt 
   Caption         =   "Simple Encryption"
   ClientHeight    =   4665
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6300
   LinkTopic       =   "Form1"
   ScaleHeight     =   4665
   ScaleWidth      =   6300
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdExit 
      Caption         =   "E&xit"
      Height          =   315
      Left            =   5100
      TabIndex        =   10
      Top             =   4260
      Width           =   1035
   End
   Begin VB.TextBox txtDecrypted 
      Height          =   915
      Left            =   1440
      MultiLine       =   -1  'True
      TabIndex        =   9
      Top             =   3240
      Width           =   4695
   End
   Begin VB.CommandButton cmdDecrypt 
      Caption         =   "&Decrypt"
      Height          =   315
      Left            =   1440
      TabIndex        =   7
      Top             =   2844
      Width           =   1275
   End
   Begin VB.TextBox txtEncrypted 
      Height          =   915
      Left            =   1440
      MultiLine       =   -1  'True
      TabIndex        =   6
      Top             =   1848
      Width           =   4695
   End
   Begin VB.CommandButton cmdEncrypt 
      Caption         =   "&Encrypt"
      Height          =   315
      Left            =   1440
      TabIndex        =   4
      Top             =   1452
      Width           =   1275
   End
   Begin VB.TextBox txtOriginal 
      Height          =   915
      Left            =   1440
      MultiLine       =   -1  'True
      TabIndex        =   3
      Text            =   "frmSimpleEncrypt.frx":0000
      Top             =   456
      Width           =   4695
   End
   Begin VB.TextBox txtPasswd 
      Height          =   315
      Left            =   1440
      TabIndex        =   1
      Top             =   60
      Width           =   2595
   End
   Begin VB.Label Label4 
      Caption         =   "Decrypted Text:"
      Height          =   255
      Left            =   120
      TabIndex        =   8
      Top             =   3240
      Width           =   1215
   End
   Begin VB.Label Label3 
      Caption         =   "Encrypted Text:"
      Height          =   255
      Left            =   120
      TabIndex        =   5
      Top             =   1848
      Width           =   1215
   End
   Begin VB.Label Label2 
      Caption         =   "Original Text:"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   456
      Width           =   1215
   End
   Begin VB.Label Label1 
      Caption         =   "Password:"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1215
   End
End
Attribute VB_Name = "frmSimpleEncrypt"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub cmdDecrypt_Click()
'*************************************************************
'* Written By: Davis Chapman
'* Date:       September 06, 1999
'*
'* Syntax:     cmdDecrypt_Click
'*
'* Parameters:  None
'*
'* Purpose: This function is called when the user clicks the
'*          Decrypt button. It checks to make sure that the
'*          user has entered a password and that there is
'*          encrypted data to be decrypted. It then calls the
'*          DoDecrypt subroutine.
'*************************************************************
    '-- Do we have a password?
    If txtPasswd.Text = "" Then
        MsgBox "You must provide a password to use for encrypting the message."
        txtPasswd.SetFocus
        
    '-- Do we have encrypted data?
    ElseIf txtEncrypted.Text = "" Then
        MsgBox "You must encrypt some text before decrypting."
        txtOriginal.SetFocus
    
    '-- We can perform the decryption
    Else
        DoDecrypt
    End If
End Sub

Private Sub cmdEncrypt_Click()
'*************************************************************
'* Written By: Davis Chapman
'* Date:       September 06, 1999
'*
'* Syntax:     cmdEncrypt_Click
'*
'* Parameters:  None
'*
'* Purpose: This function is called when the user clicks the
'*          Encrypt button. It checks to make sure that the
'*          user has entered a password and that there is
'*          message data to be encrypted. It then calls the
'*          DoEncrypt subroutine.
'*************************************************************
    '-- Do we have a password?
    If txtPasswd.Text = "" Then
        MsgBox "You must provide a password to use for encrypting the message."
        txtPasswd.SetFocus
    
    '-- Do we have message data?
    ElseIf txtOriginal.Text = "" Then
        MsgBox "You must enter some text to be encrypted."
        txtOriginal.SetFocus
    
    '-- We can perform the encryption
    Else
        DoEncrypt
    End If
End Sub

Private Sub cmdExit_Click()
    '-- Exit the application
    Unload Me
End Sub


Private Sub DoEncrypt()
'*************************************************************
'* Written By: Davis Chapman
'* Date:       September 06, 1999
'*
'* Syntax:     DoEncrypt
'*
'* Parameters:  None
'*
'* Purpose: This subroutine creates an instance of the Crypto
'*          class, copies the password and message data to the
'*          password and input buffer properties of the class,
'*          and then performs the encryption in three steps.
'*          First, it creates a session key from the password.
'*          Second, it encrypts the message using the session
'*          key. Third, it destroys the session key. Finally,
'*          the encrypted message is copied from the output
'*          buffer property to the encrypted data control.
'*************************************************************
    '-- Create an instance of the encryption class
    Dim csCrypt As New clsCrypto
    
    '-- Set the password and input buffer properties
    csCrypt.Password = txtPasswd.Text
    csCrypt.InBuffer = txtOriginal.Text
    
    '-- Generate the password based session key
    If Not csCrypt.GeneratePasswordKey Then _
        Exit Sub
        
    '-- Encrypt the message data
    If Not csCrypt.EncryptMessageData Then _
        Exit Sub
            
    '-- Destroy the session key
    csCrypt.DestroySessionKey
    
    '-- Copy the encrypted data to the display control
    txtEncrypted.Text = csCrypt.OutBuffer
End Sub

Private Sub DoDecrypt()
'*************************************************************
'* Written By: Davis Chapman
'* Date:       September 06, 1999
'*
'* Syntax:     DoDecrypt
'*
'* Parameters:  None
'*
'* Purpose: This subroutine creates an instance of the Crypto
'*          class, copies the password and encrypted data to the
'*          password and input buffer properties of the class,
'*          and then performs the decryption in three steps.
'*          First, it creates a session key from the password.
'*          Second, it decrypts the message using the session
'*          key. Third, it destroys the session key. Finally,
'*          the decrypted message is copied from the output
'*          buffer property to the decrypted data control.
'*************************************************************
    '-- Create an instance of the encryption class
    Dim csCrypt As New clsCrypto
    
    '-- Set the password and input buffer properties
    csCrypt.Password = txtPasswd.Text
    csCrypt.InBuffer = txtEncrypted.Text
    
    '-- Generate the password based session key
    If Not csCrypt.GeneratePasswordKey Then _
        Exit Sub
        
    '-- Decrypt the message data
    If Not csCrypt.DecryptMessageData Then _
        Exit Sub
            
    '-- Destroy the session key
    csCrypt.DestroySessionKey
    
    '-- Copy the decrypted data to the display control
    txtDecrypted.Text = csCrypt.OutBuffer
End Sub
